//+------------------------------------------------------------------+
//|                                           ind_Zakruglenie_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Violet
#property indicator_color3 DeepSkyBlue
//---- input parameters
extern int       ExtParam1;
//---- buffers
double val[];
double a1[];
double a2[];

double s[];
double u[];
double ss[];
double su[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   IndicatorBuffers(7);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,val);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,a1);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,a2);
   
   SetIndexBuffer(3,s);   
   SetIndexBuffer(4,u);  
   
   SetIndexBuffer(5,ss);   
   SetIndexBuffer(6,su);      
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               val[i]=iStochastic(NULL,0,5,5,3,0,0,1,i);
               s[i]=val[i]-val[i+1];
            }
            for(i=limit-1;i>=0;i--){
               ss[i]=iMAOnArray(s,0,3,0,1,i);  
               u[i]=ss[i]-ss[i+1];             
            }            
            for(i=limit-1;i>=0;i--){
               su[i]=iMAOnArray(u,0,3,0,1,i);  
               a1[i]=EMPTY_VALUE;
               a2[i]=EMPTY_VALUE; 
                  if(ss[i]>0 && ss[i+1]>0 && ss[i+2]>0){
                     if(su[i]<0){
                        a1[i]=val[i];
                     }
                  }
                  if(ss[i]<0 && ss[i+1]<0 && ss[i+2]<0){
                     if(su[i]>0){
                        a2[i]=val[i]; 
                     }
                  }                     
            }

   return(0);
}

